from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes
from charmhelpers.core import hookenv


class AuditRequires(RelationBase):
    scope = scopes.GLOBAL

    @hook('{requires:audit}-relation-changed')
    def changed(self):
        self.name = self.get_remote('name')
        self.rules = self.get_remote('rules', '').splitlines()

        if self.name is not None and self.rules != []:
            self.set_state('{relation_name}.available')
        else:
            hookenv.log("Audit relation missing name and rules, skipping")

    @hook('{requires:audit}-relation-{departed,broken}')
    def broken(self):
        self.remove_state('{relation_name}.available')
        self.set_state('{relation_name}.broken')
